// SessionPropertiesFileTypesPage.cpp : implementation file
//

#include "stdafx.h"
#include "MirrorIt.h"
#include "SessionPropertiesFileTypesPage.h"
#include "CheckTreeCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSessionPropertiesFileTypesPage property page

IMPLEMENT_DYNCREATE(CSessionPropertiesFileTypesPage, CPropertyPage)

CSessionPropertiesFileTypesPage::CSessionPropertiesFileTypesPage() : CPropertyPage(CSessionPropertiesFileTypesPage::IDD)
{
	//{{AFX_DATA_INIT(CSessionPropertiesFileTypesPage)
	m_BMimeTypes = FALSE;
	//}}AFX_DATA_INIT
}

CSessionPropertiesFileTypesPage::~CSessionPropertiesFileTypesPage()
{
}

void CSessionPropertiesFileTypesPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSessionPropertiesFileTypesPage)
	DDX_Control(pDX, IDC_MIMETYPES, m_MimeTypes);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSessionPropertiesFileTypesPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSessionPropertiesFileTypesPage)
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectall)
	ON_BN_CLICKED(IDC_UNSELECTALL, OnUnselectall)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSessionPropertiesFileTypesPage message handlers

BOOL CSessionPropertiesFileTypesPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	if (m_imagelist.Create(IDB_STATEICONS, 16, 1, RGB(255,0,0)))
	{
		m_MimeTypes.SetImageList(&m_imagelist, TVSIL_NORMAL);
	}

	CStringList & str = ((CMirrorItApp *)AfxGetApp()) -> m_MimeTypes;
	POSITION item = str.GetHeadPosition();
	while (item != NULL)
		addsubnode(str.GetNext(item));

	HTREEITEM first = m_MimeTypes.GetNextItem(NULL, TVGN_CHILD);
	while (first != NULL)
	{
		CString main = m_MimeTypes.GetItemText(first);

		HTREEITEM child = m_MimeTypes.GetChildItem(first);
		while (child != NULL)
		{
			CString sub = m_MimeTypes.GetItemText(child);
			if (m_LMimeTypes.Find(main + "/" + sub))
				m_MimeTypes.CheckItem(child);

			child = m_MimeTypes.GetNextSiblingItem(child);
		}

		first = m_MimeTypes.GetNextSiblingItem(first);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

HTREEITEM CSessionPropertiesFileTypesPage::addrootnode(CString str)
{
	TV_INSERTSTRUCT is;
	is.hParent = TVI_ROOT;
	is.hInsertAfter = TVI_SORT;
	is.item.mask = TVIF_IMAGE | TVIF_TEXT;
	is.item.iImage = 0;
	is.item.iSelectedImage = 0;
	is.item.pszText = (LPSTR)(LPCSTR) str;
	return m_MimeTypes.InsertItem(&is);
}

HTREEITEM CSessionPropertiesFileTypesPage::addsubnode(CString str)
{
	CString main, sub;

	main = str.Left(str.Find('/'));
	sub = str.Mid(str.Find('/') + 1);

	HTREEITEM first = m_MimeTypes.GetNextItem(NULL, TVGN_CHILD);
	while (first != NULL && m_MimeTypes.GetItemText(first) != main)
	{
		first = m_MimeTypes.GetNextSiblingItem(first);
	}
	if (first == NULL)
		first = addrootnode(main);

	TV_INSERTSTRUCT is;
	is.hParent = first;
	is.hInsertAfter = TVI_LAST;
	is.item.mask = TVIF_IMAGE | TVIF_TEXT;
	is.item.iImage = 0;
	is.item.iSelectedImage = 0;
	is.item.pszText = (LPSTR)(LPCSTR) sub;
	return m_MimeTypes.InsertItem(&is);
}

void CSessionPropertiesFileTypesPage::OnSelectall() 
{
	m_MimeTypes.UnCheckTree(TVI_ROOT, 1);
}

void CSessionPropertiesFileTypesPage::OnUnselectall() 
{
	m_MimeTypes.UnCheckTree(TVI_ROOT, 0);
}

void CSessionPropertiesFileTypesPage::OnDestroy() 
{
	m_LMimeTypes.RemoveAll();

	HTREEITEM first = m_MimeTypes.GetNextItem(NULL, TVGN_CHILD);
	while (first != NULL)
	{
		CString main = m_MimeTypes.GetItemText(first);

		HTREEITEM child = m_MimeTypes.GetChildItem(first);
		while (child != NULL)
		{
			CString sub = m_MimeTypes.GetItemText(child);
			int n, s;

			m_MimeTypes.GetItemImage(child, n, s);
			if (n == 1)
				m_LMimeTypes.AddTail(main + "/" + sub);

			child = m_MimeTypes.GetNextSiblingItem(child);
		}

		first = m_MimeTypes.GetNextSiblingItem(first);
	}
	
	CPropertyPage::OnDestroy();

}
